////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Unit Name : Main
//  * Purpose   :     HTML 
//  * Author    :  (Rouse_) 
//  * Copyright :  :)
//  * Version   : 1.01
//  ****************************************************************************
//

unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, XPMan, ComCtrls, GSStorage, ExtCtrls, ShellCtrls;

resourcestring
  //STR_RESULT = '\Result\';
  HEADER = 'header.inc';
  AEND = 'end.inc';

const
  //        
  // ( 7 ,     )
  MSG = 'T';  // <msg dt
  TID = 'D';  // <trd id
  DSC = 'S';  // <trd dsc
  FRM = ' ';  // <forum dsc

  CLRF = #13#10;
  EXT = '.html';
  HDR1 = '<A HREF="%s">  </A>';
  HDR11 = '  ';
  HDR2 = '<A HREF="%s"></A>';
  HDR3 = '<A HREF="%s">  </A>';
  HDR31 = '  ';
  HDR4 = '<center><TABLE border=0 width=88%><TR align=right nowrap><TD>';
  HDR5 = '</TD></TR><TR><TD colspan=2><IMG SRC="punktir.gif" WIDTH="100%" HEIGHT="1" BORDER=0 ALT=""></TD></TR></TABLE></CENTER>';
  VER1 = CLRF + '<h4><IMG height=15 alt=""src="icon.gif" width=15 border=0>' +
    '%s<font color="#808080"> %s</font></h4>';
  VER2 = CLRF + '<h4><IMG height=15 alt=""src="icon.gif" width=15 border=0>%s</h4>';
  TOP1 = '<h3><P align=center> "%s"<DIV class=dsc><SMALL>' +
    '<font color="#808080">%s</font></SMALL></DIV></P></h3>';
  MSG1 = '%s &nbsp;<font color=green><small>(%s)</small></font>&nbsp;' + 
    '<small>[%s]</small><BR>' +
    '<p style="margin-left: 20; margin-right: 20">%s</P><HR>';
  MSG2 = '<IMG height=15 alt=""src="icon.gif" width=15 border=0>' +
    '<A href="%s">%s</A> (<NOBR><I>%s</I></NOBR> <FONT class=date>%s</FONT>)' +
    '<BR>&nbsp;&nbsp; <FONT color=#804040>[%s]</FONT>  <I><FONT class=dsc>' +
    '%s</FONT></I><BR>&nbsp; &nbsp;<SMALL>: %s &nbsp; %s &nbsp;</SMALL><HR>';
  MSG3 = '<IMG height=15 alt=""src="icon.gif" width=15 border=0>' + 
    '<A href="%s">%s</A> (<NOBR><I>%s</I></NOBR> <FONT class=date>%s</FONT>)' +
    '<BR>&nbsp;&nbsp;  <I><FONT class=dsc>' +
    '%s</FONT></I><BR>&nbsp; &nbsp;<SMALL>: %s &nbsp; %s &nbsp;</SMALL><HR>';

type
  TLink = String;

  TParserType = (ptMsg, ptTrdID, ptTrdDsc, ptForum, ptError);

  TTitle = packed record
    FConference: String;        //  
    FConferenceRoot: Boolean;   //    ?
    FNext: TLink;               //    
    FPrevios: TLink;            //    
    FRoot: TLink;               //    
    FTheme: String;             //  
    FVersion: String;           //     ...
    //       
    FID: String;                // ID -  
    FConferenceTitle: String;   //  
  end;

  TDigestMessage = packed record
    FMsgDate: String;           //  
    FNick: String;              //  (       )
    FPost: String;              //  
    //       
    FID: TLink;                 //   
    FTitle: String;             //  
    FVD: String;                //     ...
    FCount: String;             // - 
    FAnswers: String;           //  
  end;
  TDigestMessageArray = array of TDigestMessage;

  TDigestStruct = packed record
    FTitle: TTitle;
    FMessages: TDigestMessageArray;
    FMessageCount: Integer;
    FEnding: String;
  end;

  TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    XPManifest1: TXPManifest;
    GroupBox3: TGroupBox;
    pbProcess: TProgressBar;
    btnStart: TButton;
    btnCancel: TButton;
    StatusBar1: TStatusBar;
    ShellComboBox1: TShellComboBox;
    tvDest: TShellTreeView;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    ShellComboBox2: TShellComboBox;
    tvSrc: TShellTreeView;
    Splitter2: TSplitter;
    procedure btnCancelClick(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FStop: Boolean;
    //      HTML 
    HDRStart, HDREnd: String;
    //         
    HDRTop: String;
    //    
    HDRMsg: String;
    //    
    XMLList: TStringList;
    //    XML
    Digest: TDigestStruct;
    // 
    procedure ParseMessage(const Value: TStringList);
    procedure ParseTrdID(Value: String);
    procedure ParseTrdDsc(Value: String);
    procedure ParseForum(Value: String);
    function GetPasrseType(const Value: String): TParserType;
    procedure Parse(const Value: TStringList);
    //  
    function PrepareFolder(const Path: String): HRESULT;
    procedure Scan(Path: String);
    //  
    procedure Valid(var Path: String);
    function UpperChar(const Value: Char): Char;
    procedure ClearStruct;
    //  
    procedure CreateHTML(const Path: String);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.btnCancelClick(Sender: TObject);
begin
  if FStop then
    Close
  else
  begin
    FStop := True;
    pbProcess.Position := 0;
    btnStart.Enabled := True;
  end;
end;

function TMainForm.PrepareFolder(const Path: String): HRESULT;
var
  Storage: TGSStorage;
  ACursor: TGSStorageCursor;
  AEnum: TGSStorageEnum;
  I: Integer;
  Stream: TMemoryStream;
begin
  Result := S_FALSE;
  if not ForceDirectories(Path) then Exit;
  if not FileExists(ExtractFilePath(ParamStr(0)) + 'data.stg') then Exit;
  Storage := TGSStorage.Create;
  try
    Storage.OpenFileReadOnly(ExtractFilePath(ParamStr(0)) + 'data.stg', ACursor);
    ACursor.Enumerate(AEnum);
    for I := 0 to AEnum.Count - 1 do
    begin
      ACursor.ReadStream(AEnum.Enum[I].pwcsName, Stream);
      try
        if (AEnum.Enum[I].pwcsName <> HEADER) and
           (AEnum.Enum[I].pwcsName <> AEND) then
          Stream.SaveToFile(Path + AEnum.Enum[I].pwcsName)
        else
        begin
          if AEnum.Enum[I].pwcsName = HEADER then
          begin
            HDRStart := StringOfChar(#0, Stream.Size);
            Stream.Read(HDRStart[1], Stream.Size);
          end
          else
          begin
            HDREnd := StringOfChar(#0, Stream.Size);
            Stream.Read(HDREnd[1], Stream.Size);
          end;
        end;
        Result := S_OK;
      finally
        Stream.Free;
      end;
    end;
  finally
    Storage.Free;
  end;
end;

function TMainForm.GetPasrseType(const Value: String): TParserType;
begin
  if Value = '' then
  begin
    Result := ptError;
    Exit;
  end;
  case UpperChar(Value[7]) of
    MSG: Result := ptMsg;
    TID: Result := ptTrdID;
    DSC: Result := ptTrdDsc;
    FRM: Result := ptForum;
  else
    Result := ptError;
  end;
end;

procedure TMainForm.Parse(const Value: TStringList);
var
  I: Integer;
  TmpStrings: TStringList;
begin
  ClearStruct;
  I := 2;
  TmpStrings := TStringList.Create;
  try
    while I < Value.Count do
    begin
      if FStop then Exit;
      case GetPasrseType(Value.Strings[I]) of
        ptMsg:
        begin
          TmpStrings.Text := Value.Strings[I] + CLRF +
            Value.Strings[I + 1] + CLRF + Value.Strings[I + 2];
          Inc(I, 2);
          ParseMessage(TmpStrings);
        end;
        ptTrdID: ParseTrdID(Value.Strings[I]);
        ptTrdDsc:ParseTrdDsc(Value.Strings[I]);
        ptForum:ParseForum(Value.Strings[I]);
      end;
      Inc(I);
      Application.ProcessMessages;
    end;
  finally
    TmpStrings.Free;
  end;
end;

procedure TMainForm.ParseForum(Value: String);
var
  I: Integer;
begin
  //     
  Digest.FTitle.FConferenceRoot := True;
  Delete(Value, 1, 12);
  I := Pos('"', Value);
  //  
  Digest.FTitle.FConferenceTitle := Copy(Value, 1, I - 1);
  Delete(Value, 1, Pos('frm', Value) + 4);
  I := Pos('"', Value);
  //  
  Digest.FTitle.FConference := Copy(Value, 1, I - 1);
  Delete(Value, 1, I + 4);
  I := Pos('"', Value);
  // ID 
  Digest.FTitle.FID := Copy(Value, 1, I - 1);
end;

procedure TMainForm.ParseMessage(const Value: TStringList);
var
  I: Integer;
  TmpStr: String;
  Replase: String;
begin
  Inc(Digest.FMessageCount);
  SetLength(Digest.FMessages, Digest.FMessageCount);
  TmpStr := Value.Strings[0];
  Delete(TmpStr, 1, 9);
  I := Pos('"', TmpStr);
  //  
  Digest.FMessages[Digest.FMessageCount - 1].FMsgDate := Copy(TmpStr, 1, I - 1);
  TmpStr := Value.Strings[1];
  //    (    )
  Digest.FMessages[Digest.FMessageCount - 1].FNick :=
    Copy(TmpStr, 7, Length(TmpStr) - 12);
  TmpStr := Value.Strings[2];
  //  
  Replase := Copy(TmpStr, 7, Length(TmpStr) - 12);
  Replase := StringReplace(Replase, '<br/>', '<br>', [rfReplaceAll]);
  Digest.FMessages[Digest.FMessageCount - 1].FPost := Replase;
end;

procedure TMainForm.ParseTrdDsc(Value: String);
var
  I: Integer;
begin
  //        
  Digest.FTitle.FConferenceRoot := False;
  Delete(Value, 1, 10);
  I := Pos('"', Value);
  //  
  Digest.FTitle.FConference := Copy(Value, 1, I - 1);
  Delete(Value, 1, I + 6);
  I := Pos('"', Value);
  //    
  Digest.FTitle.FPrevios := Copy(Value, 1, I - 1);
  Delete(Value, 1, I + 6);
  I := Pos('"', Value);
  //    
  Digest.FTitle.FNext := Copy(Value, 1, I - 1);
  Delete(Value, 1, I + 6);
  I := Pos('"', Value);
  //    
  Digest.FTitle.FRoot := Copy(Value, 1, I - 1);
  Delete(Value, 1, Pos('tit', Value) + 4);
  I := Pos('"', Value);
  //  
  Digest.FTitle.FTheme := Copy(Value, 1, I - 1);
  Delete(Value, 1, I + 5);
  I := Pos('"', Value);
  //    ...
  Digest.FTitle.FVersion := Copy(Value, 1, I - 1);

end;

procedure TMainForm.ParseTrdID(Value: String);
var
  I: Integer;
begin
  Inc(Digest.FMessageCount);
  SetLength(Digest.FMessages, Digest.FMessageCount);
  Delete(Value, 1, 9);
  I := Pos('"', Value);
  //   
  Digest.FMessages[Digest.FMessageCount - 1].FID :=
    Digest.FTitle.FID + '-' + Copy(Value, 1, I - 1) + EXT;
  Delete(Value, 1, I + 8);
  I := Pos('"', Value);
  //  
  Digest.FMessages[Digest.FMessageCount - 1].FTitle := Copy(Value, 1, I - 1);
  Delete(Value, 1, I + 7);
  I := Pos('"', Value);
  //  
  Digest.FMessages[Digest.FMessageCount - 1].FNick := Copy(Value, 1, I - 1);
  Delete(Value, 1, I + 5);
  I := Pos('"', Value);
  //     
  Digest.FMessages[Digest.FMessageCount - 1].FMsgDate := Copy(Value, 1, I - 1);
  Delete(Value, 1, I + 6);
  I := Pos('"', Value);
  //    
  Digest.FMessages[Digest.FMessageCount - 1].FPost := Copy(Value, 1, I - 1);
  Delete(Value, 1, I + 5);
  I := Pos('"', Value);
  //    ...
  Digest.FMessages[Digest.FMessageCount - 1].FVD := Copy(Value, 1, I - 1);
  Delete(Value, 1, I + 8);
  I := Pos('"', Value);
  //  
  Digest.FMessages[Digest.FMessageCount - 1].FCount := Copy(Value, 1, I - 1);
  Delete(Value, 1, I + 10);
  I := Pos('"', Value);
  //  
  Digest.FMessages[Digest.FMessageCount - 1].FAnswers := Copy(Value, 1, I - 1);
end;

procedure TMainForm.CreateHTML(const Path: String);
var
  ResultStream: TStringList;
  I: Integer;
  Tmp: String;
begin
  HDRTop := '';
  Tmp := '';
  HDRMsg := '';
  //    ,     ...
  if Digest.FTitle.FConferenceRoot then
  begin
    HDRTop := Format(TOP1, [Digest.FTitle.FConference, Digest.FTitle.FConferenceTitle]);
    for I := 0 to Digest.FMessageCount - 1 do
      if Digest.FMessages[I].FVD = '' then
        HDRMsg := HDRMsg + Format(MSG3, [Digest.FMessages[I].FID,
          Digest.FMessages[I].FTitle, Digest.FMessages[I].FNick,
          Digest.FMessages[I].FMsgDate, 
          Digest.FMessages[I].FPost, Digest.FMessages[I].FCount,
          Digest.FMessages[I].FAnswers]) + CLRF
      else
        HDRMsg := HDRMsg + Format(MSG2, [Digest.FMessages[I].FID,
          Digest.FMessages[I].FTitle, Digest.FMessages[I].FNick,
          Digest.FMessages[I].FMsgDate, Digest.FMessages[I].FVD,
          Digest.FMessages[I].FPost, Digest.FMessages[I].FCount,
          Digest.FMessages[I].FAnswers]) + CLRF;
  end
  else
  begin
    //     
    if Digest.FTitle.FPrevios <> '' then
      HDRTop := Format(HDR1, [Digest.FTitle.FPrevios + EXT])
    else
      HDRTop := HDR11;
    //    
    HDRTop := HDRTop + ' | ' + Format(HDR2, [ChangeFileExt(Digest.FTitle.FRoot, EXT)]);
    //     
    if Digest.FTitle.FNext <> '' then
      HDRTop := HDRTop + ' | ' + Format(HDR3, [Digest.FTitle.FNext + EXT])
    else
      HDRTop := HDRTop + ' | ' + HDR31;
    // ,     
    Tmp := '<BR><P align=left nowrap>' + HDRTop + '</P>';
    //  
    HDRTop := HDR4 + HDRTop + HDR5;
    //     ( )      :)
    if Digest.FTitle.FVersion = '' then
      HDRTop := HDRTop + Format(VER2, [Digest.FTitle.FTheme])
    else
      HDRTop := HDRTop + Format(VER1, [Digest.FTitle.FTheme,
        Digest.FTitle.FVersion]);
    //       
    HDRMsg := '';
    for I := 0 to Digest.FMessageCount - 1 do
      HDRMsg := HDRMsg + Format(MSG1, [Digest.FMessages[I].FNick,
        Digest.FMessages[I].FMsgDate, IntToStr(I),
        Digest.FMessages[I].FPost]) + CLRF;
  end;
  //  
  ResultStream := TStringList.Create;
  try
    ResultStream.Text := HDRStart + HDRTop + HDRMsg + Tmp + HDREnd;
    ResultStream.SaveToFile(Path);
  finally
    ResultStream.Free;
  end;
end;

procedure TMainForm.Scan(Path: String);
var
  SR: TSearchRec;
begin
  XMLList.Clear;
  Valid(Path);
  Path := Path + '*.xml';
  if FindFirst(Path, faAnyFile, SR) = 0 then
  begin
    repeat
      XMLList.Add(SR.Name);
    until FindNext(SR) <> 0;
    FindClose(SR);
  end;  
end;

procedure TMainForm.btnStartClick(Sender: TObject);
var
  TmpXML: TStringList;
  Dest, Src: String;
  I: Integer;
begin
  Dest := tvDest.Path;
  Src := tvSrc.Path;
  Valid(Dest);
  FStop := False;
  if PrepareFolder(Dest) = S_OK then
  begin
    Valid(Src);
    Scan(Src);
    pbProcess.Max := XMLList.Count;
    pbProcess.Position := 0;
    btnStart.Enabled := False;
    for I := 0 to XMLList.Count - 1 do
    begin
      TmpXML := TStringList.Create;
      try
        TmpXML.LoadFromFile(Src + XMLList.Strings[I]);
        Parse(TmpXML);
        if FStop then Exit;
        CreateHTML(Dest + ChangeFileExt(XMLList.Strings[I], EXT));
        pbProcess.Position := I + 1;
        Application.ProcessMessages;
      finally
        TmpXML.Free;
      end;
    end;
    pbProcess.Position := 0;
    btnStart.Enabled := True;
    FStop := True;
  end;  
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FStop := True;
  XMLList := TStringList.Create;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  XMLList.Free;
end;

procedure TMainForm.Valid(var Path: String);
begin
  if Path[Length(Path)] <> '\' then
    Path := Path + '\';
end;

function TMainForm.UpperChar(const Value: Char): Char;
var
  TmpStr: String;
begin
  if Length(Value) > 1 then
  begin
    Result := ' ';
    Exit;
  end;
  TmpStr := UpperCase(Value);
  Result := TmpStr[1];
end;

procedure TMainForm.ClearStruct;
begin
  FillChar(Digest.FTitle, SizeOf(TTitle), #0);
  Digest.FMessageCount := 0;
  SetLength(Digest.FMessages, 0);
  Digest.FEnding := '';
end;

end.
