unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, GSStorage, StdCtrls, CheckLst, FWOpenDirectory;

type
  TMakeResMainForm = class(TForm)
    lbRes: TCheckListBox;
    edBrowse: TEdit;
    btnBrowse: TButton;
    btnCreate: TButton;
    OpenDirectory: TFWOpenDirectory;
    SaveDialog: TSaveDialog;
    procedure btnBrowseClick(Sender: TObject);
    procedure btnCreateClick(Sender: TObject);
  private
    procedure Scan;
  end;

var
  MakeResMainForm: TMakeResMainForm;

implementation

{$R *.dfm}

procedure TMakeResMainForm.btnBrowseClick(Sender: TObject);
begin
  if OpenDirectory.Execute then
  begin
    edBrowse.Text := OpenDirectory.DirName;
    Scan;
  end;
end;

procedure TMakeResMainForm.Scan;
var
  SR: TSearchRec;
begin
  lbRes.Items.BeginUpdate;
  try
    lbRes.Items.Clear;
    if FindFirst(edBrowse.Text + '\*.*', faAnyFile, SR) = 0 then
    begin
      repeat
        if (SR.Name <> '.') and (SR.Name <> '..') then
        begin
          lbRes.Items.Add(SR.Name);
          lbRes.Checked[lbRes.Count -1] := True;
        end;
      until FindNext(SR) <> 0;
      FindClose(SR);
    end;
  finally
    lbRes.Items.EndUpdate;
    btnCreate.Enabled := lbRes.Count > 0;
  end;
end;

procedure TMakeResMainForm.btnCreateClick(Sender: TObject);
var
  Storage: TGSStorage;
  ACursor: TGSStorageCursor;
  I: Integer;
  FS: TMemoryStream;
begin
  if SaveDialog.Execute then
    Storage := TGSStorage.Create;
  try
    Storage.OpenFile(SaveDialog.FileName, True, ACursor);
    try
      for I := 0 to lbRes.Count - 1 do
        if lbRes.Checked[I] then
        begin
          FS := TMemoryStream.Create;
          try
            FS.LoadFromFile(Format('%s\%s',
              [edBrowse.Text, lbRes.Items.Strings[I]]));
            FS.Position := 0;
            ACursor.WriteStream(lbRes.Items.Strings[I], FS);
          finally
            FS.Free;
          end;
        end;
    finally
      ACursor.Release;
    end;
  finally
    Storage.Free;
  end;
  ShowMessage('  ');
end;

end.
